<template>

  <div>
    <el-card :body-style="cardBodyStyle">
      <el-form :inline="true">
        <el-form-item label="计量时间" style="margin-bottom: 5px;" prop="jlsj">
          <el-date-picker
              v-model="query.jlsj"
              type="date"
              placeholder="请选择日期"
          />
        </el-form-item>
      </el-form>
    </el-card>
    <el-card :body-style="cardBodyStyle">
      <el-button type="primary" plain @click="handleSearch">查询</el-button>
    </el-card>
    <el-card :body-style="cardBodyStyle">
      <el-table :data="tableData" border highlight-current-row @selection-change="handleSelectionChange"
                row-key="id">
        <el-table-column v-if="true" prop="jlh" label="计量号" width="0"  header-align="center" align="center"
                         show-overflow-tooltip>
        </el-table-column>
        <el-table-column v-if="true" prop="fhdwmc" label="发货单位" width="0" header-align="center" align="center"
                         show-overflow-tooltip>
        </el-table-column>
        <el-table-column v-if="true" prop="shdwmc" label="收货单位" width="0" header-align="center" align="center"
                         show-overflow-tooltip>
        </el-table-column>
        <el-table-column v-if="true" prop="carno" label="车号" width="0" header-align="center" align="center"
                         show-overflow-tooltip>
        </el-table-column>
        <el-table-column v-if="true" prop="shdwmc" label="收货单位" width="0" header-align="center" align="center"
                         show-overflow-tooltip>
        </el-table-column>





      </el-table>
    </el-card>
    <el-card :body-style="cardBodyStyle">
      <el-pagination :current-page="currentPage" :page-size="pageSize" :page-sizes="pageSizes" :total="totalRows"
                     background="background" layout="total, sizes, prev, pager, next, jumper"
                     @size-change="handleSizeChange"
                     @current-change="handleCurrentChange">
      </el-pagination>
    </el-card>
    <el-dialog custom-class="centered-form" :close-on-click-modal="false"></el-dialog>

    <el-dialog custom-class="centered-form" :close-on-click-modal="false" draggable :title="title_dialog"
               v-model="dialogVisible" width="1200px"
               top="5vh" @open="openDialog">
      <el-form :model="form" border label-width="120px" label-position="left" inline ref="ruleFormRef" :rules="rules">
        <el-form-item label="名称" prop="name">
          <el-input v-model="form.name" clearable style="width: 200px"></el-input>
        </el-form-item>

        <el-form-item label="汽车组批数" prop="qichezpcs">
          <el-input-number min="0" v-model="form.qichezpcs" clearable style="width: 200px"
                           :disabled="form.remark==='产品类别'"></el-input-number>
        </el-form-item>
        <el-form-item label="火车组批数" prop="huochezpcs">
          <el-input-number min="0" v-model="form.huochezpcs" clearable style="width: 200px"
                           :disabled="form.remark==='产品类别'"></el-input-number>
        </el-form-item>
        <el-form-item label="间隔时间(小时)" prop="jiangesj">
          <el-input-number v-model="form.jiangesj" min:0 clearable style="width: 200px"
                           :disabled="form.remark==='产品类别'"></el-input-number>
        </el-form-item>

      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="success" @click="handleSave(ruleFormRef)">保存</el-button>
          <el-button type="danger" @click="handleCancelSave">取消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup>


import {
  ref,
  reactive,
  onMounted,
  getCurrentInstance
} from 'vue'

const {
  proxy
} = getCurrentInstance()

import tools from '@/tools'
import {ElMessage, ElMessageBox} from "element-plus";
import ButtonBar from "@/components/ButtonBar.vue";

const cardBodyStyle = ref(tools.style.card)
const inputStyle = ref(tools.style.input)

onMounted(() => {

})


/**
 *   查询
 */


const query = ref({
  jlsj: ''
})
const tableData = ref([])
const handleSearch = () => {
  currentPage.value = 1
  getTableData()
}

const getTableData = () => {
  var url = 'syi/Leibie/query'
  var param = {
    page: currentPage.value,
    rows: pageSize.value,
    params: JSON.stringify(query.value)
  }
  proxy.$axios.get(url, param).then(response => {
    if (response.data.code == '0') {
      tableData.value = response.data.data.records
      // console.log(response.data.data)
      console.log(tableData.value)
      totalRows.value = response.data.data.total
    } else {
      ElMessage.error('操作失败！' + response.data.msg)
    }
  })
}


/**
 *   查询
 */

/**
 * 分页
 */
const currentPage = ref(1)
const totalRows = ref(0)
const pageSizes = ref([5, 10, 20, 30, 40])
const pageSize = ref(5)
const handleSizeChange = (val) => {
  pageSize.value = val
  getTableData()
}
const handleCurrentChange = (val) => {
  currentPage.value = val
  getTableData()
}
/**
 * 分页
 */


/**
 * 新增
 */
const dialogVisible = ref(false)
const form = ref({
  name: '',
  remark: '',
  erpbm: '',
  sortindex: '',
  enabled: '1',
  parentid: '',
  laiyuan: '录入',
  qichezpcs: '',
  huochezpcs: '',
  jiangesj: ''
})
const ruleFormRef = ref()
const rules = reactive({
  name: [{
    required: true,
    message: '请输入物料名称',
    trigger: 'change' | 'blur'
  }],
  qichezpcs: [{
    required: true,
    message: '请输入',
    trigger: 'change' | 'blur'
  }],
  huochezpcs: [{
    required: true,
    message: '请输入',
    trigger: 'change' | 'blur'
  }],
  jiangesj: [{
    required: true,
    message: '请输入',
    trigger: 'change' | 'blur'
  }]
})

const title_dialog = ref('')
const handleAdd = () => {
  title_dialog.value = '新增'
  form.value = {
    name: '',
    remark: '',
    erpbm: '',
    sortindex: '',
    enabled: '',
    laiyuan: '录入',
  }
  getTreeData()
  dialogVisible.value = true
}
/**
 * 新增
 */


/**
 * 保存、修改、删除
 */

const openDialog = () => {
}

const handleSave = (ruleFormRef) => {
  ruleFormRef.validate((valid, fields) => {
    if (valid) {
      var url = 'syi/Leibie/save'
      var param = {
        json: JSON.stringify(form.value),
      }
      proxy.$axios.post(url, param).then(response => {
        if (response.data.code == 0) {
          form.value = response.data.data
          ElMessage({
            message: '保存成功',
            type: 'success',
          })
          getTableData()
          dialogVisible.value = false
        } else {
          // ElMessage.error('操作失败！' + response.data.msg)
          ElMessage({
            message: '操作失败' + response.data.msg,
            type: 'error'
          })
        }
      })

    } else {
      console.log('error submit!', fields)
    }
  })
}
const handleCancelSave = () => {
  dialogVisible.value = false
}
const handleEdit = (row) => {
  title_dialog.value = '编辑'
  getTreeData()
  dialogVisible.value = true
  form.value = JSON.parse(JSON.stringify(row))
}
const handleDelete = (row) => {
  if (row.children && row.children.length > 0) {
    ElMessage({
      type: 'warning',
      message: '请先删除子节点或者使用批量删除功能',
    })
    return
  }
  ElMessageBox.confirm(
      '确定删除本条记录?',
      '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning',
        draggable: true,
      }
  )
      .then(() => {
        var url = 'syi/Leibie/remove'
        var param = {
          id: row.id
        }
        proxy.$axios.post(url, param).then(response => {
          if (response.data.code == 0) {
            ElMessage({
              type: 'success',
              message: '删除成功',
            })
            getTableData()
          } else {
            ElMessage({
              type: 'error',
              message: '删除失败' + response.data.msg
            });
          }
        });
      })
      .catch(() => {
        ElMessage({
          type: 'info',
          message: '已取消',
        })
      })
}

/**
 * 保存、修改、删除
 */

const multipleSelection = ref([])
const handleSelectionChange = (val) => {
  multipleSelection.value = val
}

const handleRemoveBatch = () => {
  console.log('handleRemoveBatch')

  if (multipleSelection.value.length < 1) {
    ElMessage({
      type: 'warning',
      message: '请选择要删除的数据!'
    })
    return
  }

  ElMessageBox.confirm('此操作将删除该数据, 是否继续?', '提示', {
    confirmButtonText: '确定',
    cancelButtonText: '取消',
    type: 'warning'
  }).then(() => {
    var ids = []
    multipleSelection.value.forEach((item, index) => {
      ids.push(item.id)
    })
    var url = 'syi/Leibie/removeBatch'
    var param = {
      ids: JSON.stringify(ids)
    }
    proxy.$axios.post(url, param).then(response => {
      if (response.data.code == '0') {
        ElMessage({
          type: 'success',
          message: '操作成功!',
        });
        getTableData()
        dialogVisible.value = false
      } else {
        ElMessage({
          type: 'error',
          message: '操作失败!' + response.data.msg
        });
      }
    })
  }).catch(() => {
    ElMessage({
      type: 'info',
      message: '已取消删除'
    })
  })
}

const handleChange = (row) => {
  var url = 'syi/Leibie/save'
  var param = {
    json: JSON.stringify(row),
  }
  proxy.$axios.post(url, param).then(response => {
    if (response.data.code == 0) {
      ElMessage({
        message: '保存成功',
        type: 'success',
      })
      getTableData()
      dialogVisible.value = false
    } else {
      // ElMessage.error('操作失败！' + response.data.msg)
      ElMessage({
        message: '操作失败' + response.data.msg,
        type: 'error'
      })
    }
  })
}


</script>

<style>
.centered-form .el-dialog__body {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100%;
}
</style>


